import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;


public aspect Dispatcher advises ItemProducing, ConsumerCreation {
	
	List consumer = new ArrayList();	
	
	after(ConsumerCreation creation) returning {
		System.out.println("[dispatcher] add new consumer: "+creation.consumer.getName());
		consumer.add(creation.consumer);
	}
	
	
	after(ItemProducing producing) returning(Item it) {
		System.out.println("[dispatch] recieve item : "+it.value);
		boolean check = check(it);
		if(check) {
			dispatch(it);
		} else {
			System.out.println("[checking] invalid value "+it.value+"! item rejected");
		}
	}
	
	private boolean check(Item it) {
		return it.value != 0;
	}
	
	private void dispatch(final Item it) {
		Runnable r = new Runnable() {
			public void run() {				
				System.out.println("[dispatch] search for idle consumer");
				
				boolean searching = true;
				int tries = 0;
				while(searching) {				
					if(tries > 0) {
						System.out.println("[dispacth] no consumer idle, try again");
					}
					for(Iterator i = consumer.iterator(); i.hasNext();) {
						Consumer c = (Consumer) i.next();
						if(!c.isWorking()) {
							System.out.println("[dispatch] "+c.getName()+" is idle ...");
							c.consume(it);
							searching = false;
							break;
						}
						System.out.println("[dispatch] "+c.getName()+" is busy");
					}
					tries++;
					try {
						Thread.sleep(1000);
					} catch(InterruptedException e) {
						System.err.println(e);
					}
				}			
			}
		};
		
		Thread th = new Thread(r);
		th.start();
		
	}
	
	
	
	
}